//+------------------------------------------------------------------+
//|                                                       2*2_MA.mq4 |
//|                                                     Yuriy Tokman |
//|                                            yuriytokman@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Yuriy Tokman"
#property link      "yuriytokman@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

extern string TimeFrame     = "Current time frame";
extern int    period_1      = 13 ;
extern int    period_2      = 55 ;
extern int    ma_method     = 1;
extern int    applied_price = 0;

double ExtMapBuffer1[];
double ExtMapBuffer2[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars"; if (returnBars) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" 2*2_MA("+period_1+","+period_2+")");
   SetIndexLabel(0,"EURUSD");
   SetIndexLabel(1,"GBPUSD");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int y,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { ExtMapBuffer1[0] = MathMin(limit+1,Bars-1); return(0); }
            if (Symbol()!="EURUSD" || timeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom("EURUSD",timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            if (Symbol()!="GBPUSD" || timeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom("GBPUSD",timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //
   
   double p1 = MarketInfo("EURUSD",MODE_POINT);
   double p2 = MarketInfo("GBPUSD",MODE_POINT);
   for(int i=limit; i>=0; i--)
   {
      y = iBarShift("EURUSD",timeFrame,Time[i]);
         double MA1 = iMA("EURUSD",timeFrame,period_1,0,ma_method,applied_price,y);
         double MA2 = iMA("EURUSD",timeFrame,period_2,0,ma_method,applied_price,y);
            ExtMapBuffer1[i]=(MA1-MA2)/p1;
     
      y = iBarShift("GBPUSD",timeFrame,Time[i]);
         double MA11 = iMA("GBPUSD",timeFrame,period_1,0,ma_method,applied_price,y);
         double MA22 = iMA("GBPUSD",timeFrame,period_2,0,ma_method,applied_price,y);
            ExtMapBuffer2[i]=(MA11-MA22)/p2;     
   }
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}